#undef USE_FOG

float4x4 viewProjMatrix : register (c0);
float4x4 worldMatrix : register (c4);
float4 worldEye : register (c8);
float4 fogData : register (c9);
float4 ownerPos : register (c14);
float4x4 shadowProj : register (c16);
float4x4 shadowView : register (c20);

struct VS_OUTPUT
{
   float4 Pos  : POSITION;
#ifdef USEFOG
   float  Fog  : FOG;
#endif   
   float2 Proj : TEXCOORD0; // projected texture
   float2 Tex  : TEXCOORD1; // base texture
};

#if BUMP == 1
 VS_OUTPUT vs11_shadowProjectBumpStrip (float4 inPos : POSITION, float4 inNorm : NORMAL, float2 inTex : TEXCOORD0)
#else 
 VS_OUTPUT vs11_shadowProjectStrip (float4 inPos : POSITION, float4 inNorm : NORMAL, float2 inTex : TEXCOORD0)
#endif
{
  VS_OUTPUT Out;
  
  // Transform vertex position into view space
  Out.Pos = mul (viewProjMatrix, inPos);

#ifdef USEFOG
  float3 eyeVec = worldEye + mul (worldMatrix, inPos);
  Out.Fog = (fogData[1] - (length (eyeVec) * fogData[0]));
#endif   
  
  //float3 posVec = normalize (ownerPos + mul (worldMatrix, inPos));
  //float3 worldNorm = mul (worldMatrix, inNorm.xyz);
  //if (dot (worldNorm, posVec) < 0.0F)
  //{
  //  Out.Proj.xy = 0.0F;
  //}
  //else
  {
    float3 t = mul (shadowView, inPos);
    Out.Proj.xy = mul (shadowProj, t / t.z);
  }  
  Out.Tex = inTex;

  return (Out);
}

