#define USEFOG

float4x4 viewProjMatrix : register (c0);
float4x4 worldMatrix : register (c4);
float4x4 shadowProj : register (c16);
float4x4 shadowView : register (c20);

struct VS_OUTPUT
{
   float4 Pos  : POSITION;
   float2 Tex0 : TEXCOORD0;
   //float2 Tex1 : TEXCOORD1;
};

VS_OUTPUT vs11_shadowProjectTex (float4 inPos : POSITION, float2 inTex : TEXCOORD0)
{
  VS_OUTPUT Out;
  
  // Transform vertex position into view space (view is the light's view):
  Out.Pos = mul (viewProjMatrix, inPos);
  float3 worldPos = mul (worldMatrix, inPos);

  // Propogate texture coordinates
  //Out.Tex0 = inTex;
  
  // Project texture coordinates
  float3 t = mul (shadowView, worldPos);
  Out.Tex0.xy = mul (shadowProj, t / t.z);

  return (Out);
}

